'From OLPC2.0 of ''24 October 2006'' [latest update: #1355] on 18 November 2007 at 11:22:32 pm'!
MorphicModel subclass: #KnobMorph
	instanceVariableNames: 'value controller point nowDegree oldPos newPos minValue maxValue minDegree maxDegree turningState valueString max min minValueString maxValueString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakByExample'!
!KnobMorph commentStamp: 'picxenk 9/20/2007 20:44' prior: 0!
volume control nob !


!KnobMorph methodsFor: 'initialization' stamp: 'picxenk 9/20/2007 16:06'!
defaultBorderColor
	"answer the default border color/fill style for the receiver"
	^ Color black.! !

!KnobMorph methodsFor: 'initialization' stamp: 'picxenk 10/17/2007 15:06'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 0! !

!KnobMorph methodsFor: 'initialization' stamp: 'picxenk 9/20/2007 16:07'!
defaultBounds
"answer the default bounds for the receiver"
	^ 0 @ 0 corner: 100 @ 100! !

!KnobMorph methodsFor: 'initialization' stamp: 'picxenk 10/17/2007 15:05'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color r: 0.8 g: 0.6 b: 0.3! !


!KnobMorph methodsFor: 'events' stamp: 'picxenk 9/20/2007 17:14'!
mouseDownIn: event

	oldPos := event hand position.! !

!KnobMorph methodsFor: 'events' stamp: 'picxenk 9/20/2007 16:41'!
mouseUpIn: event! !

!KnobMorph methodsFor: 'events' stamp: 'picxenk 9/24/2007 19:24'!
turnController: event

	| var |
	newPos := event hand position.
	var := newPos x - oldPos x.

	turningState := #none.
	var > 0 ifTrue: [turningState := #right].
	var < 0 ifTrue: [turningState := #left].

	nowDegree := (nowDegree + (var * 1.5)).
	self updateValue: nowDegree.
	self setNobHeading: nowDegree.
	oldPos := newPos.

"	Transcript show: 'old:',oldPos asString,'---','new:',newPos asString; cr."
	Transcript show: nowDegree; show: '--'; show: value; show: turningState; cr.! !


!KnobMorph methodsFor: 'access' stamp: 'picxenk 9/20/2007 16:47'!
controller

	^ controller! !

!KnobMorph methodsFor: 'access' stamp: 'picxenk 9/24/2007 19:20'!
maxDegree

	^maxDegree! !

!KnobMorph methodsFor: 'access' stamp: 'picxenk 10/17/2007 19:50'!
maxDegree: degree

	maxDegree := degree.
! !

!KnobMorph methodsFor: 'access' stamp: 'picxenk 10/17/2007 19:52'!
maxVal

	^maxValue.! !

!KnobMorph methodsFor: 'access' stamp: 'picxenk 9/24/2007 19:21'!
maxValue: aValue

	maxValue := aValue! !

!KnobMorph methodsFor: 'access' stamp: 'picxenk 9/24/2007 19:20'!
minDegree

	^minDegree! !

!KnobMorph methodsFor: 'access' stamp: 'picxenk 10/17/2007 19:50'!
minDegree: degree

	minDegree := degree.
! !

!KnobMorph methodsFor: 'access' stamp: 'picxenk 10/17/2007 19:52'!
minVal

	^minValue.! !

!KnobMorph methodsFor: 'access' stamp: 'picxenk 9/24/2007 19:21'!
minValue: aValue

	minValue := aValue! !

!KnobMorph methodsFor: 'access' stamp: 'picxenk 10/17/2007 20:31'!
setMaxVal: aValue

	maxValue := aValue.
	maxValueString contents: aValue asString.! !

!KnobMorph methodsFor: 'access' stamp: 'picxenk 10/17/2007 20:31'!
setMinVal: aValue

	minValue := aValue.
	minValueString contents: aValue asString.! !

!KnobMorph methodsFor: 'access' stamp: 'picxenk 9/24/2007 19:21'!
value

	^value! !


!KnobMorph methodsFor: 'initialize' stamp: 'picxenk 10/17/2007 20:29'!
drawBackground

	| shadow form pen |
	shadow := EllipseMorph new.
	shadow color: (Color r: 0.3 g: 0.2 b: 0); extent: 70@70.
	self addMorph: shadow.
	shadow center: self center + (2@2).

	form := Form extent: 100@100.
	pen := Pen newOnForm: form.
	pen down.
	pen turn: minDegree.
	1 to: 100 do: [:d |
		pen place: self center.
		pen turn: (maxDegree - minDegree) abs / 100.
		(( d = 1) or: [d \\ 10 = 0]) ifTrue: [ pen go: 42 ] ifFalse: [pen go: 38 ]
	].
	self addMorph: form asMorph.

	minValueString := StringMorph contents: minValue asString.
	maxValueString := StringMorph contents: maxValue asString.

	self addMorph: minValueString.
	self addMorph: maxValueString.
	minValueString center: self center + (-30@40).
	maxValueString center: self center + (30@40).! !

!KnobMorph methodsFor: 'initialize' stamp: 'picxenk 10/17/2007 20:26'!
drawController

	self drawBackground.
	self initializeController.! !

!KnobMorph methodsFor: 'initialize' stamp: 'picxenk 10/17/2007 19:49'!
initialize

	super initialize.
	value := 0.0.
	minValue := 0.
	maxValue := 100.
	minDegree := -150.
	maxDegree := 150.
	nowDegree := 0.

	self drawController.
! !

!KnobMorph methodsFor: 'initialize' stamp: 'picxenk 10/17/2007 20:23'!
initializeController



	controller := EllipseMorph new.
	controller color: Color yellow; extent: 70@70.

	point := EllipseMorph new.
	point color: Color red; extent: 3@3; borderWidth: 0.
	controller addMorph: point.
	point center: controller center - (0@30).
	self addMorph: controller.
	controller center: self center.

	valueString := StringMorph contents: value asString.
	self addMorph: valueString.
	valueString center: self center + (0@10).

	controller on: #mouseMove send: #turnController: to: self.
	controller on: #mouseDown send: #mouseDownIn: to: self.
! !


!KnobMorph methodsFor: 'as yet unclassified' stamp: 'picxenk 9/24/2007 18:15'!
setNobHeading: degree

	controller heading: degree! !

!KnobMorph methodsFor: 'as yet unclassified' stamp: 'picxenk 10/17/2007 20:20'!
updateValue: degree

	(degree >= minDegree and: [degree <= maxDegree]) ifTrue: [
		nowDegree := degree.
	].
	degree < minDegree ifTrue: [ nowDegree := minDegree ].
	degree > maxDegree ifTrue: [ nowDegree := maxDegree ].

	value :=  (nowDegree - minDegree) / ((maxDegree - minDegree) abs / (maxValue - minValue)) + minValue.
	valueString contents: value asFloat asString.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

KnobMorph class
	instanceVariableNames: ''!

!KnobMorph class methodsFor: 'as yet unclassified' stamp: 'picxenk 11/18/2007 23:21'!
additionsToViewerCategories
	^ #((knob
(
"
(slot minDegree 'The min degree of knob' Number readWrite Player getMinDegree Player setMinDegree:)
(slot maxDegree 'The max degree of knob' Number readWrite Player getMaxDegree Player setMaxDegree:)
"
(slot minValue 'The min value of knob' Number readWrite Player getMinVal Player setMinVal:)
(slot maxValue 'The max value of knob' Number readWrite Player getMaxVal Player setMaxVal:)
(slot value 'The value of knob' Number readOnly Player getValue unused unused)
)) )! !
