'From OLPC2.0 of ''24 October 2006'' [latest update: #1355] on 16 November 2007 at 2:16:48 am'!

!Player methodsFor: 'costume' stamp: 'led 11/15/2007 20:04'!
getValueFromCostume: aSelector fromValue: arg
	| aCostume |
	
	(aCostume _ self costumeRespondingTo: aSelector) ifNotNil:
		[^ aCostume perform: aSelector withArguments: (Array with: arg)].
	^ nil! !

!Player methodsFor: 'scripts-standard' stamp: 'led 11/16/2007 00:58'!
forward: dist 
	"Move forward (viz. in the direction of my heading) by the given amount"

	| rho radians delta didStray p aCostume aPlayfield |
	(aCostume _ self costume) isInWorld ifFalse: [^ self].
	aCostume isWorldOrHandMorph ifTrue: [^ self].
	aCostume owner isHandMorph ifTrue: [^ self].

	rho _ (aCostume asNumber: dist) asFloat.
	radians _ (self getHeadingUnrounded asFloat - 90.0) degreesToRadians.
	delta _ (radians cos @ radians sin) * rho.

	(aPlayfield _ aCostume pasteUpMorph) fenceEnabled ifTrue:
		[(aPlayfield bounds containsRect: aCostume bounds) ifFalse:
			["If I stray out of the bounds of my playfield, pull me back, but
			 without changing my heading as bounce would. Do nothing if
			 bounce has already corrected the direction."
			didStray _ false.
			((aCostume left < aPlayfield left and: [delta x < 0]) or:
			 [aCostume right > aPlayfield right and: [delta x > 0]]) ifTrue:
				[delta _ delta x negated @ delta y.
				didStray _ true].
			((aCostume top < aPlayfield top and: [delta y < 0]) or:
			 [aCostume bottom > aPlayfield bottom and: [delta y > 0]]) ifTrue:
				[delta _ delta x @ delta y negated.
				didStray _ true].
			(didStray and: [Preferences fenceSoundEnabled]) ifTrue: [aCostume makeFenceSound]]].

	"use and record the fractional position"
	p _ aCostume referencePosition + delta.
	aCostume referencePosition: p! !

!Player methodsFor: '*skeleton-base' stamp: 'shrew 11/16/2007 02:14'!
getColumn 
	^ self getValueFromCostume: #column 

! !

!Player methodsFor: '*skeleton-base' stamp: 'shrew 11/16/2007 02:14'!
getCursor 
	^ self getValueFromCostume: #cursor 

! !

!Player methodsFor: '*skeleton-base' stamp: 'shrew 11/16/2007 02:14'!
getCursorValue 
	^ self getValueFromCostume: #cursorValue

! !

!Player methodsFor: '*skeleton-base' stamp: 'shrew 11/16/2007 02:14'!
getRow 
	^ self getValueFromCostume: #row 

! !

!Player methodsFor: '*skeleton-base' stamp: 'shrew 11/16/2007 02:15'!
setColumn: aNumber
	self setCostumeSlot: #column: toValue: aNumber 

! !

!Player methodsFor: '*skeleton-base' stamp: 'shrew 11/16/2007 02:15'!
setCursorValue: aNumber 
	self setCostumeSlot: #cursorValue: toValue: aNumber 

! !

!Player methodsFor: '*skeleton-base' stamp: 'shrew 11/16/2007 02:15'!
setCursor: aPoint 
	self setCostumeSlot: #cursor: toValue: aPoint 

! !

!Player methodsFor: '*skeleton-base' stamp: 'shrew 11/16/2007 02:15'!
setRow: aNumber
	self setCostumeSlot: #row: toValue: aNumber 

! !

!Player methodsFor: '*SqueakByExample' stamp: 'led 11/15/2007 19:55'!
getValue

	^ self getValueFromCostume: #value! !


!SkSheetMorph methodsFor: 'as yet unclassified' stamp: 'shrew 11/16/2007 02:13'!
column
  
	^ self cursor y ! !

!SkSheetMorph methodsFor: 'as yet unclassified' stamp: 'shrew 11/16/2007 02:13'!
column: aNumber
  
	self cursor:  ( (self cursor x) @ aNumber )! !

!SkSheetMorph methodsFor: 'as yet unclassified' stamp: 'shrew 11/16/2007 02:13'!
cursor
  
	self selection isNil ifTrue:[ ^0@0]
							ifFalse:[ ^ self selection origin]
		! !

!SkSheetMorph methodsFor: 'as yet unclassified' stamp: 'shrew 11/16/2007 02:14'!
cursorValue
  
	^ model
		at: self cursor
		ifAbsent: [^ '']
! !

!SkSheetMorph methodsFor: 'as yet unclassified' stamp: 'shrew 11/16/2007 02:14'!
cursorValue: aNumber
  
	model
		at: self cursor
		put: aNumber
! !

!SkSheetMorph methodsFor: 'as yet unclassified' stamp: 'shrew 11/16/2007 02:14'!
cursor: aPoint
  
	self selectSelection: aPoint

	! !

!SkSheetMorph methodsFor: 'as yet unclassified' stamp: 'shrew 11/16/2007 02:14'!
row
 
	^ self cursor x ! !

!SkSheetMorph methodsFor: 'as yet unclassified' stamp: 'shrew 11/16/2007 02:14'!
row: aNumber
  
	self cursor: ( aNumber @ (self cursor y) ) ! !


!SkSheetMorph class methodsFor: 'as yet unclassified' stamp: 'shrew 11/16/2007 02:10'!
additionsToViewerCategories  
	^ #(('SkSheet'
	(
	(slot row 'The sheet data of A1' Number readWrite Player getRow Player setRow:)
	(slot column 'The sheet data of A1' Number readWrite Player getColumn Player setColumn:)
	(slot cursor 'The sheet data of A1' Point readWrite Player getCursor Player setCursor:)
	(slot cursorValue 'The sheet data of A1' Number readWrite Player getCursorValue Player setCursorValue:)
	
	)
	))! !

SkSheetMorph removeSelector: #getPoint:!
Player removeSelector: #at:!
Player removeSelector: #at:put:!
Player removeSelector: #column!
Player removeSelector: #column:!
Player removeSelector: #cursor!
Player removeSelector: #cursorValue!
Player removeSelector: #cursorValue:!
Player removeSelector: #cursor:!
Player removeSelector: #getColumn:!
Player removeSelector: #getPoint!
Player removeSelector: #getPoint:!
Player removeSelector: #row!
Player removeSelector: #row:!
Player removeSelector: #setPoint:setValue:!
Player removeSelector: #textAt:put:!
